//----------------------------------------------------------------------//
// NyanFi																//
//  UNCpX̑݃`FbNEXbh										//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include "check_thread.h"

#pragma package(smart_init)

//---------------------------------------------------------------------------
//Xbh̏
//---------------------------------------------------------------------------
__fastcall TCheckPathThread::TCheckPathThread(bool CreateSuspended) : TThread(CreateSuspended)
{
	Priority		= tpLower;
	FreeOnTerminate = true;

	TaskRWLock = new TMultiReadExclusiveWriteSynchronizer();

	PathName = EmptyStr;
	isOk	 = false;
}

//---------------------------------------------------------------------------
UnicodeString __fastcall TCheckPathThread::GetPathName()
{
	TaskRWLock->BeginRead();
	UnicodeString v = FPathName;
	TaskRWLock->EndRead();
	return v;
}
//---------------------------------------------------------------------------
void __fastcall TCheckPathThread::SetPathName(UnicodeString Value)
{
	TaskRWLock->BeginWrite();
	FPathName = Value;
	TaskRWLock->EndWrite();
}

//---------------------------------------------------------------------------
void __fastcall TCheckPathThread::Execute()
{
	while (!Terminated) {
		if (!PathName.IsEmpty()) {
			isOk	 = ::PathIsDirectory(PathName.c_str());
			PathName = EmptyStr;
		}
		Sleep(50);
	}

	delete TaskRWLock;
}
//---------------------------------------------------------------------------
